package params

import (
	"encoding/json"

	"gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/common/caps"
)

type UserWithPwd struct {
	Email     string                `json:"email"     validate:"required,email"`
	FirstName string                `json:"firstname" validate:"required,min=2,max=32"`
	LastName  string                `json:"lastname"  validate:"required,min=2,max=32"`
	Pwd       string                `json:"pwd"       validate:"required,min=8"`
	Caps      caps.UserCapabilities `json:"caps"      validate:"required"`
}

type UserWithoutPwd struct {
	Email     string                `json:"email"     validate:"required,email"`
	FirstName string                `json:"firstname" validate:"required,min=2,max=32"`
	LastName  string                `json:"lastname"  validate:"required,min=2,max=32"`
	Caps      caps.UserCapabilities `json:"caps"      validate:"required"`
}

type UserSetCaps struct {
	Caps caps.UserCapabilities
}

type UserSetPwd struct {
	Pwd string `json:"pwd" validate:"required,min=8"`
}

// Converts a User structure into a pretty string.
func (user *UserWithoutPwd) String() string {
	output, err := json.MarshalIndent(user, "", "    ")
	if err != nil {
		return err.Error()
	}

	return string(output)
}
