package params

import (
	"gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/common/caps"
	"gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/common/vm"

	"github.com/google/uuid"
)

type VMCreate struct {
	Name       string     `json:"name"       validate:"required,min=1,max=256"`
	Cpus       int        `json:"cpus"       validate:"required,gte=1,lte=32"`
	Ram        int        `json:"ram"        validate:"required,gte=128,lte=32768"`
	Nic        vm.NicType `json:"nic"`
	UsbDevs    []string   `json:"usbDevs"`
	TemplateID uuid.UUID  `json:"templateID" validate:"required"`
}

type VMStartWithCreds struct {
	Pwd string `json:"pwd"        validate:"required,min=10,max=64"`
}

type VMAttachCreds struct {
	Pwd string `json:"pwd"        validate:"required,min=10,max=64"`
}

type VMEdit struct {
	Name    string     `json:"name"       validate:"required,min=1,max=256"`
	Cpus    int        `json:"cpus"       validate:"required,gte=1,lte=32"`
	Ram     int        `json:"ram"        validate:"required,gte=128,lte=32768"`
	Nic     vm.NicType `json:"nic"`
	UsbDevs []string   `json:"usbDevs"`
}

type VMAddAccess struct {
	Access caps.VMAccessCapabilities `json:"access"  validate:"required"`
}

type VMExportDir struct {
	Dir string `json:"dir"`
}
